package pwc.taxtech.atms.vat.service.impl.report.functions;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.OperandResolver;
import org.apache.poi.ss.formula.eval.ValueEval;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class FunctionBase {
    protected final Logger logger = LoggerFactory.getLogger(this.getClass());

    protected FormulaContext formulaContext;

    public FunctionBase(FormulaContext formulaContext){
        this.formulaContext = formulaContext;
    }

    public String getStringParam(ValueEval valueEval, OperationEvaluationContext ec) {
        try {
            ValueEval v1 = OperandResolver.getSingleValue(valueEval,
                    ec.getRowIndex(),
                    ec.getColumnIndex());
            return OperandResolver.coerceValueToString(v1);
        } catch (EvaluationException e) {
            e.printStackTrace();
            return null;
        }
    }

    public Integer getIntParam(ValueEval valueEval, OperationEvaluationContext ec) {
        try {
            ValueEval v1 = OperandResolver.getSingleValue(valueEval,
                    ec.getRowIndex(),
                    ec.getColumnIndex());
            return OperandResolver.coerceValueToInt(v1);
        } catch (EvaluationException e) {
            e.printStackTrace();
            return null;
        }
    }

    public Long getCellTemplateID(int period, OperationEvaluationContext ec){
       return FormulaHelper
                .getCellTemplateIDWithTemplateCodeAndColumnIndexAndRowIndex(ec.getWorkbook().getSheetName(ec.getSheetIndex()),ec.getColumnIndex(),ec.getRowIndex(),period,formulaContext);
    }
}
